doe.sim<-function(f, x, N.sim=100, threshold=NULL, alpha.threshold=0.05, max.step=7)
{
  flag<-TRUE
  step<-0
  tmp<-c()

  while (flag&(step<max.step)) {
    step<-step+1
    tmp<-c(tmp,replicate(N.sim,f(x)))
    mean.f<-mean(tmp)
    sd.f<-sd(tmp)/sqrt(length(tmp))
    if (is.null(threshold)) 
      flag<-FALSE
    else if (abs(threshold-mean.f)>qnorm(1-alpha.threshold/2)*sd.f) 
      flag<-FALSE
    N.sim<-N.sim*2
  }

  if (step==max.step) warning(paste("max.step limit =",max.step,"reached"))

  return(mean.f)
}

