doe.uniroot<-function(f,lower,upper,trace=TRUE, max.iter=1000, 
                      xtype=c("integer","real"),...,tol=.Machine$double.eps^0.25,
                      f.lower=f(lower,...),f.upper=f(upper,...))
{

  xtype<-match.arg(xtype)

  if (xtype=="integer") { 

    if (f.lower>0) {
      warning(paste("Even",lower,"seem to be sufficient."))
      return(lower)
    }
    iter<-1
    while (f.upper<0 & iter<max.iter) {
      iter<-iter*2
      upper<-upper*2
      f.upper<-f(upper,...)
    } 
    if (iter>=max.iter) stop(paste("max.iter limit =",max.iter,"reached"))
    
    iter<-0
    while ((upper-lower!=1)&(iter<max.iter)) {
      if (trace) cat(paste("Interval:",lower,upper,"\n"))
      iter<-iter+1
      new<-round((lower+upper)/2)
      f.new<-f(new,...)
      if (sign(f.new)==0) return(new)
      if (sign(f.new)==sign(f.lower)) {
        lower<-new
        f.lower<-f.new
      }
      else {
        upper<-new
        f.upper<-f.new
      }
    }
    
    if (iter==max.iter) warning(paste("max.iter limit =",max.iter,"reached"))
    
    return(upper)    
  }
  else {
    iter<-0
    while (f.upper<0 & iter<max.iter) {
      iter<-iter+1
      upper<-upper*2
      f.upper<-f(upper,...)
    }
    if (iter>=max.iter) stop(paste("max.iter limit =",max.iter,"reached"))
    iter<-0
    while (f.lower>0 & iter<max.iter) {
      iter<-iter+1
      lower<-lower/2
      f.lower<-f(lower,...)
    } 
    if (iter>=max.iter) stop(paste("max.iter limit =",max.iter,"reached"))
    
    if (trace) cat(paste("Searching interval:",lower,upper,"\n"))
    x<-uniroot(f,lower=lower,upper=upper,f.lower=f.lower,f.upper=f.upper,
               maxiter=max.iter,tol=tol,...)$root
    return(x)           
  }
}

