sim.p.test<-function(n,p,alpha=0.05,
                       target=c("p.value","conf.int"), target.ci=c("typeA","typeB"),
                       type=c("one.sample","two.sample"),
                       alternative=c("two.sided", "less", "greater")) 
{

  target<-match.arg(target)
  target.ci<-match.arg(target.ci)
  type<-match.arg(type)
  alternative<-match.arg(alternative)

  if (type=="two.sample"&length(n)==1) n<-c(n,n)
  if (type=="two.sample"&length(p)==1) p<-c(p,p)

  if (target=="conf.int") {
    nwarn<-getOption("warn")
    options(warn=-1)
    if (type=="one.sample") 
      tmp<-binom.test(rbinom(1,n,p),n,alternative=alternative,conf.level=1-alpha)
    else 
      tmp<-prop.test(rbinom(2,n,p),n,alternative=alternative,conf.level=1-alpha)
    options(warn=nwarn)
        
    if (target.ci=="typeA") return(switch(alternative,
      two.sided=diff(tmp$conf.int)/2,
      less=tmp$conf.int[2]-tmp$estimate,
      greater=tmp$estimate-tmp$conf.int[1]))
    else return(as.vector(switch(alternative,
      two.sided=tmp$conf.int,
      less=tmp$conf.int[2],
      greater=tmp$conf.int[1])))  
  }
  else {
    nwarn<-getOption("warn")
    options(warn=-1)
    if (type=="one.sample") 
      tmp<-binom.test(rbinom(1,n,p[1]),n,p=p[2],alternative=alternative,conf.level=1-alpha)$p.value
    else 
      tmp<-prop.test(rbinom(2,n,p),n,alternative=alternative,conf.level=1-alpha)$p.value
    options(warn=nwarn)  
    if (is.na(tmp)) tmp<-1
    return(tmp)
      
  }
}  

